diff -urN Terminal-0.4.4.orig/po/en_GB.po Terminal-0.4.4/po/en_GB.po
--- Terminal-0.4.4.orig/po/en_GB.po	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/po/en_GB.po	2010-05-12 05:57:13.000000000 +0400
@@ -1057,6 +1057,12 @@
 msgid "Scroll single _line using Shift-Up/-Down keys"
 msgstr "Scroll single _line using Shift-Up/-Down keys"
 
+msgid "Scroll buttons replacing by Fx`s codes"
+msgstr "Scroll buttons replacing by Fx`s codes"
+
+msgid "Enable this option to remap Shift+PgUp to F13, Shift+PgDn to F14, Shift+Home to F15 and Shift+End to F16. With this hack you can now use these keys in your application, but scrollback future will be disabled."
+msgstr "Enable this option to remap Shift+PgUp to F13, Shift+PgDn to F14, Shift+Home to F15 and Shift+End to F16. With this hack you can now use these keys in your application, but scrollback future will be disabled."
+
 #: ../Terminal.glade.h:74
 msgid "Scroll_back:"
 msgstr "Scroll_back:"
diff -urN Terminal-0.4.4.orig/po/ru.po Terminal-0.4.4/po/ru.po
--- Terminal-0.4.4.orig/po/ru.po	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/po/ru.po	2010-05-12 12:55:18.000000000 +0400
@@ -986,6 +986,12 @@
 msgid "Scroll on _keystroke"
 msgstr "Прокручивать при _нажатии клавиши"
 
+msgid "Scroll buttons remap to Fx`s codes"
+msgstr "Переназначение клавиш прокрутки к кодам Fx"
+
+msgid "Enable this option to remap Shift+PgUp to F13, Shift+PgDn to F14, Shift+Home to F15 and Shift+End to F16. With this hack you can now use these keys in your application, but scrollback future will be disabled."
+msgstr "Включите этот параметр, если хотите использовать переназначение Shift+PgUp на F13, Shift+PgDn на F14, Shift+Home на F15 и Shift+End на F16. С этим хаком вы сможете использовать данные сочетания клавиш в своих программах, но функция прокрутки будет отключена."
+
 #: ../Terminal.glade.h:72
 msgid "Scroll on ou_tput"
 msgstr "Прокручивать по мере _вывода"
diff -urN Terminal-0.4.4.orig/terminal/terminal-preferences.c Terminal-0.4.4/terminal/terminal-preferences.c
--- Terminal-0.4.4.orig/terminal/terminal-preferences.c	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/terminal/terminal-preferences.c	2010-05-12 06:28:33.000000000 +0400
@@ -125,6 +125,7 @@
   PROP_SCROLLING_ON_OUTPUT,
   PROP_SCROLLING_ON_KEYSTROKE,
   PROP_SCROLLING_SINGLE_LINE,
+  PROP_SCROLLING_FN_HACK,
   PROP_SHORTCUTS_NO_MENUKEY,
   PROP_SHORTCUTS_NO_MNEMONICS,
   PROP_TITLE_INITIAL,
@@ -1215,6 +1216,17 @@
                                                          EXO_PARAM_READWRITE));
 
   /**
+   * TerminalPreferences:scrolling-fn-hack:
+   **/
+  g_object_class_install_property (gobject_class,
+                                   PROP_SCROLLING_FN_HACK,
+                                   g_param_spec_boolean ("scrolling-fn-hack",
+                                                         "scrolling-fn-hack",
+                                                         "ScrollingFnHack",
+                                                         FALSE,
+                                                         EXO_PARAM_READWRITE));
+
+  /**
    * TerminalPreferences:scrolling-single-line:
    *
    * Whether to enable scrolling single lines using Shift-Up/-Down.
diff -urN Terminal-0.4.4.orig/terminal/terminal-preferences-dialog.c Terminal-0.4.4/terminal/terminal-preferences-dialog.c
--- Terminal-0.4.4.orig/terminal/terminal-preferences-dialog.c	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/terminal/terminal-preferences-dialog.c	2010-05-12 04:19:42.000000000 +0400
@@ -84,6 +84,7 @@
   const gchar   *props_active[] = { "title-mode", "command-login-shell",
                                     "command-update-records", "scrolling-single-line",
                                     "scrolling-on-output", "scrolling-on-keystroke",
+                                    "scrolling-fn-hack",
                                     "scrolling-bar", "font-allow-bold",
                                     "misc-menubar-default", "misc-toolbars-default",
                                     "misc-borders-default", "color-selection-use-default",
diff -urN Terminal-0.4.4.orig/terminal/terminal-widget.c Terminal-0.4.4/terminal/terminal-widget.c
--- Terminal-0.4.4.orig/terminal/terminal-widget.c	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/terminal/terminal-widget.c	2010-05-12 04:46:51.000000000 +0400
@@ -613,6 +613,7 @@
 {
   GtkAdjustment *adjustment = VTE_TERMINAL (widget)->adjustment;
   gboolean       scrolling_single_line;
+  gboolean       scrolling_fn_hack;
   gboolean       shortcuts_no_menukey;
   gdouble        value;
   gint           x;
@@ -621,6 +622,7 @@
   /* determine current settings */
   g_object_get (G_OBJECT (TERMINAL_WIDGET (widget)->preferences),
                 "scrolling-single-line", &scrolling_single_line,
+                "scrolling-fn-hack", &scrolling_fn_hack,
                 "shortcuts-no-menukey", &shortcuts_no_menukey,
                 NULL);
 
@@ -649,6 +651,25 @@
         }
     }
 
+  if (G_LIKELY (scrolling_fn_hack))
+  {
+    if ((event->state & GDK_SHIFT_MASK) != 0 && (event->keyval == GDK_Page_Up || event->keyval == GDK_KP_Page_Up))
+      {
+        event->keyval = GDK_F13;
+      }
+    else if ((event->state & GDK_SHIFT_MASK) != 0 && (event->keyval == GDK_Page_Down || event->keyval == GDK_KP_Page_Down))
+      {
+        event->keyval = GDK_F14;
+      }
+    else if ((event->state & GDK_SHIFT_MASK) != 0 && (event->keyval == GDK_Home || event->keyval == GDK_KP_Home))
+      {
+        event->keyval = GDK_F15;
+      }
+    else if ((event->state & GDK_SHIFT_MASK) != 0 && (event->keyval == GDK_End || event->keyval == GDK_KP_End))
+    {
+        event->keyval = GDK_F16;
+    }
+  }
   return (*GTK_WIDGET_CLASS (terminal_widget_parent_class)->key_press_event) (widget, event);
 }
 
diff -urN Terminal-0.4.4.orig/Terminal.glade Terminal-0.4.4/Terminal.glade
--- Terminal-0.4.4.orig/Terminal.glade	2010-02-01 20:07:04.000000000 +0300
+++ Terminal-0.4.4/Terminal.glade	2010-05-12 04:53:18.000000000 +0400
@@ -308,6 +308,20 @@
                               </packing>
                             </child>
                             <child>
+                              <object class="GtkCheckButton" id="scrolling-fn-hack">
+                                <property name="label" translatable="yes">Scroll buttons remap to Fx`s codes</property>
+                                <property name="visible">True</property>
+                                <property name="can_focus">True</property>
+                                <property name="receives_default">False</property>
+                                <property name="tooltip_text" translatable="yes">Enable this option to remap Shift+PgUp to F13, Shift+PgDn to F14, Shift+Home to F15 and Shift+End to F16. With this hack you can now use these keys in your application, but scrollback future will be disabled.</property>
+                                <property name="use_underline">True</property>
+                                <property name="draw_indicator">True</property>
+                              </object>
+                              <packing>
+                                <property name="position">0</property>
+                              </packing>
+                            </child>
+                            <child>
                               <object class="GtkHBox" id="hbox1">
                                 <property name="visible">True</property>
                                 <property name="spacing">12</property>
